<?php

/*
Copyright 2007  Olivier Goffart [ ogoffart at kde dot org ]

 Redistribution and use, with or without modification, are permitted 
 *** NO WARRANTY ***
 THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES
 ARE DISCLAIMED. 
*/

require("class.jabber.php");
class JabberEx extends Jabber
{
	 function SendIqEx($to = NULL, $type = 'get', $id = NULL, $payload = NULL, $from = NULL)
	 {
	 	if (!preg_match("/^(get|set|result|error)$/", $type))
	 	{
	 		unset($type);

	 		$this->AddToLog("ERROR: SendIq() #2 - type must be 'get', 'set', 'result' or 'error'");
			return FALSE;
		}
		elseif ($id)
		{
			$xml = "<iq type='$type' id='$id'";
					$xml .= ($to) ? " to='" . htmlspecialchars($to) . "'" : '';
					$xml .= ($from) ? " from='$from'" : '';
					$xml .= ">
				$payload
			</iq>";
		
			$this->SendPacket($xml);
			sleep($this->iq_sleep_timer);
			$this->Listen();
		
			return (preg_match("/^(get|set)$/", $type)) ? $this->GetFromQueueById("iq", $id) : TRUE;
		}
		else
		{
			$this->AddToLog("ERROR: SendIqEx() #1 - id is mandatory");
			return FALSE;
		}
	}
}

?>
