<?php
session_start();
header('Content-type: text/html; charset=utf-8');
 echo "<?" ?>xml version="1.0"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
                      "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<!--
Copyright 2007-2008  Olivier Goffart [ ogoffart at kde dot org ]

 Redistribution and use, with or without modification, are permitted 
 *** NO WARRANTY ***
 THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES
 ARE DISCLAIMED. 
-->

<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<style type="text/css">
li { list-style:none; display:inline;  }
address { font-size:x-small; color:gray; }
form { display: inline; }
</style>
<title></title></head>
<body>
<h1>Jabber archive web reader</h1>
<ul><li><a href="index.php">Login</a></li>
<li><a href="prefs.php">Config</a></li>
<li><a href="browse.php">Browse</a></li>
</ul>

<div>
<form method="post" action="browse.php">
<p><label>Only one JID (optional)</label><input type="text" name="with" /></p>
<p><label>Start and End date (optional) (<a href="http://www.xmpp.org/extensions/xep-0082.html">format</a>)</label>
	<input type="text" name="start_date"  /> <input type="text" name="end_date"  /> </p>
<p><label>Number of results per page</label> <input type="text" name="max" /></p>
<p><input type="hidden" value="list" name="browse"/><input type="submit"/></p>
</form>
</div>

<?php

if(	isset( $_POST['browse'] ) )
{

	require_once "xmpp_connect.inc.php";

	$JABBER = jabwebhist_connect();
	
	$rsm="<set xmlns='http://jabber.org/protocol/rsm'>";
	if( isset($_POST['max']) && is_numeric($_POST['max']) )
		$rsm.="<max>{$_POST['max']}</max>";
	if( isset($_POST['after']) &&  $_POST['after'] != "" )
		$rsm.="<after>{$_POST['after']}</after>";
	if( isset($_POST['before']) &&  $_POST['before'] != "" )
		$rsm.="<before>{$_POST['before']}</before>";
	if( isset($_POST['index']) && is_numeric($_POST['index']) )
		$rsm.="<index>{$_POST['index']}</index>";
	$rsm .= "</set>";

	$attr="";
	if( isset($_POST['with']) &&  $_POST['with'] != "" )
		$attr.=" with='{$_POST['with']}' ";
	if( isset($_POST['start_date']) &&  $_POST['start_date'] != "" )
		$attr.=" start='{$_POST['start_date']}' ";
	if( isset($_POST['end_date']) &&  $_POST['end_date'] != "" )
		$attr.=" end='{$_POST['end_date']}' ";
		
	$packet = $JABBER->SendIqEx( NULL , 'get' , "getlist" , "<list xmlns='http://www.xmpp.org/extensions/xep-0136.html#ns' $attr>$rsm</list>");
		    
	$JABBER->Disconnect(); 

			
	if ($JABBER->GetInfoFromIqType($packet) == 'result' && $JABBER->GetInfoFromIqId($packet) == "getlist" 
		   && isset($packet['iq']['#']['list'][0]['#']) )
	{
		$list = $packet['iq']['#']['list'][0]['#'];
		$rsm = $list['set'][0]['#'];
		unset($count);
		unset($index);
		if(isset($rsm))
		{
			if(isset( $rsm['count'][0]['#'] )   && is_numeric( $rsm['count'][0]['#'] ) )
				$count =  $rsm['count'][0]['#'] ;
			$first=$rsm['first'][0]['#'];
			$last=$rsm['last'][0]['#'];
			if(isset( $rsm['first'][0]['@']['index'] )   && is_numeric( $rsm['first'][0]['@']['index'] ) )
				$index=$rsm['first'][0]['@']['index'];
		}
		
	    echo "<hr/><h2>Results</h2>\n<p>";
		if(isset($count))
			echo "<em>$count</em> results \n";
		
		echo "<form method=\"post\" action=\"browse.php\">
				<input type=\"hidden\" name=\"with\" value=\"{$_POST['with']}\" />
				<input type=\"hidden\" name=\"start_date\"  value=\"{$_POST['start_date']}\" />
				<input type=\"hidden\" name=\"end_date\" value=\"{$_POST['end_date']}\"  /> 
				<input type=\"hidden\" name=\"max\" value=\"{$_POST['max']}\" />
				<input type=\"hidden\" value=\"list\" name=\"browse\"/>
				<input type=\"hidden\" name=\"before\" value=\"$first\" />
				<input type=\"submit\" value=\"previous\" />
				</form>";
		
		if($max > 0 && $count >0)
		{
			echo "<form method=\"post\" action=\"browse.php\">
					
					<input type=\"hidden\" name=\"with\" value=\"{$_POST['with']}\" />
					<input type=\"hidden\" name=\"start_date\"  value=\"{$_POST['start_date']}\" />
					<input type=\"hidden\" name=\"end_date\" value=\"{$_POST['end_date']}\"  /> 
					<input type=\"hidden\" name=\"max\" value=\"{$_POST['max']}\" />
					<select name=\"index\">";
			
			
			for($f=1;$f<=ceil($count/$max);$f++)
			{
				$val=$f*$max -1;
				$selected = "";
				if($index >= $val && $index < $val+$max )
					$selected='selected="selected"';
				echo "<option value=\"$val\" $selected>$f</option>";
			}
			echo "</select><input type=\"hidden\" value=\"list\" name=\"browse\"/><input type=\"submit\" value=\"go to page\" />
					</form>";
		
		}
		
		echo "<form method=\"post\" action=\"browse.php\">
				<input type=\"hidden\" name=\"with\" value=\"{$_POST['with']}\" />
				<input type=\"hidden\" name=\"start_date\"  value=\"{$_POST['start_date']}\" />
				<input type=\"hidden\" name=\"end_date\" value=\"{$_POST['end_date']}\"  /> 
				<input type=\"hidden\" name=\"max\" value=\"{$_POST['max']}\" />
				<input type=\"hidden\" value=\"list\" name=\"browse\"/>
				<input type=\"hidden\" name=\"after\" value=\"$last\" />
				<input type=\"submit\" value=\"next\" />
				</form>";
		
			
		echo "</p>";
		
		if(isset($list['chat']))
		{
			echo "\n\n<table>";
			foreach( $list['chat'] as $item)
			{   
				$date_enco=$item['@']['start'];
				$timestamp = strtotime( $date_enco);
				$date_deco =  date("Y-m-d H:i:s", $timestamp);
				echo "<tr><td>{$item['@']['with']}</td><td>$date_deco</td><td>{$item['@']['subject']}</td>\n";
				echo "<td><form method=\"post\" action=\"read.php\">
						<input type=\"hidden\" name=\"with\" value=\"{$item['@']['with']}\" />
						<input type=\"hidden\" name=\"start\"  value=\"{$item['@']['start']}\" />
						<input type=\"submit\" value=\"read\" />
						</form></td></tr>";
			}
			echo "</table>\n";
		}
	}
	else if ($JABBER->GetInfoFromIqType($packet) == 'error' && $JABBER->GetInfoFromIqId($packet) == "getlist")
	{
		echo "<p>The server has returned one error.  Maybe the server doesn't support archiving</p>";
		echo "<pre>&lt;".  key($packet['iq']['#']['error'][0]['#']) ."/&gt;</pre>";
		//var_export( $packet );
	}
}


?>

<hr />
<address>Jabber archive web reader, Version January 2008 <br/>
	Use version 0.14 of the XEP-0136. <br /> 
	Author: Olivier Goffart&lt;ogoffart at kde dot org&gt; </address>


</body>
</html>
