<?php
session_start();
header('Content-type: text/html; charset=utf-8');
 echo "<?"; ?>xml version="1.0"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
                      "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<!--
Copyright 2007-2008  Olivier Goffart [ ogoffart at kde dot org ]

 Redistribution and use, with or without modification, are permitted 
 *** NO WARRANTY ***
 THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES
 ARE DISCLAIMED. 
-->

<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<style type="text/css">
.from td:first-child { color:#BD2134; font-weight:bold; }
.to td:first-child { color:#1E6CC6;  font-weight:bold; }

li { list-style:none; display:inline;  }
address { font-size:x-small; color:gray; }
</style>
<title></title></head>
<body>
<h1>Jabber archive web reader</h1>
<ul><li><a href="index.php">Login</a></li>
<li><a href="prefs.php">Config</a></li>
<li><a href="browse.php">Browse</a></li>
</ul>

<?php

if(	isset( $_POST['with'] ) )
{

	require_once "xmpp_connect.inc.php";

	$JABBER = jabwebhist_connect();
	
	$rsm="<set xmlns='http://jabber.org/protocol/rsm'>";
	if( isset($_POST['max']) && is_numeric($_POST['max']) )
		$rsm.="<max>{$_POST['max']}</max>";
	if( isset($_POST['after']) &&  $_POST['after'] != "" )
		$rsm.="<after>{$_POST['after']}</after>";
	if( isset($_POST['before']) &&  $_POST['before'] != "" )
		$rsm.="<before>{$_POST['before']}</before>";
	if( isset($_POST['index']) && is_numeric($_POST['index']) )
		$rsm.="<index>{$_POST['index']}</index>";
	$rsm .= "</set>";

	$attr="";
	if( isset($_POST['with']) &&  $_POST['with'] != "" )
		$attr.=" with='{$_POST['with']}' ";
	if( isset($_POST['start']) &&  $_POST['start'] != "" )
		$attr.=" start='{$_POST['start']}' ";
		
	$packet = $JABBER->SendIqEx( NULL , 'get' , "getsss" , "<retrieve xmlns='http://www.xmpp.org/extensions/xep-0136.html#ns' $attr>$rsm</retrieve>");
		    
	$JABBER->Disconnect(); 
//	echo "<pre>" . var_export( $packet , true ) . "</pre>";
	
	if ($JABBER->GetInfoFromIqType($packet) == 'result' && $JABBER->GetInfoFromIqId($packet) == "getsss" 
		   && isset($packet['iq']['#']['chat'][0]['#']) )
	{

		$store = $packet['iq']['#']['chat'][0]['#'];

		$to_jid = htmlspecialchars ( $packet['iq']['#']['chat'][0]['@']['with'] );
		$us_jid = htmlspecialchars( $_SESSION['user'] .'@' .$_SESSION['server']  );

		$date_enco=$packet['iq']['#']['chat'][0]['@']['start'];
		$start_tim = strtotime( $date_enco );

		echo "<h3>Conversation with $to_jid on ".date("D M j Y",$start_tim)."</h3>";
		
		echo "<table>";
		$to=0;
		$from=0;


		
		//the sorting is not perfect (two message may have the same sec,  but this is a bug in class.jabber.php
		do
		{
			if( isset( $store['from'][$from] ) && 
					( !isset( $store['to'][$to] ) || $store['from'][$from]['@']['secs'] < $store['to'][$to]['@']['secs'] ) )
			{
				$time = date("H:i:s",  $start_tim + $store['from'][$from]['@']['secs'] );
				echo "<tr class=\"from\"><td>[$time] $to_jid :</td><td>".
						htmlspecialchars($store['from'][$from]['#']['body'][0]['#'])
						."</td></tr>";
				$from++;
				continue;
			}
			else if( isset( $store['to'][$to] ) )
			{
				$time = date("H:i:s",  $start_tim + $store['from'][$to]['@']['secs'] );
				echo "<tr class=\"to\"><td>[$time] $us_jid :</td><td>".
						htmlspecialchars($store['to'][$to]['#']['body'][0]['#'])
						."</td></tr>";
				$to++;
				continue;
			}
			else break;
		} while(true);
		
		echo "</table>";
	}
	else if ($JABBER->GetInfoFromIqType($packet) == 'error')
	{
		echo "<p>The server has returned one error.</p>";
		echo "<pre>&lt;".  key($packet['iq']['#']['error'][0]['#']) ."/&gt;</pre>";
		//var_export( $packet );
	}

}

?>


<hr />
<address>Jabber archive web reader, Version January 2008 <br/>
	Use version 0.14 of the XEP-0136. <br /> 
	Author: Olivier Goffart&lt;ogoffart at kde dot org&gt; </address>

</body>
</html>
