<?php
/*
Copyright 2007  Olivier Goffart [ ogoffart at kde dot org ]

 Redistribution and use, with or without modification, are permitted 
 *** NO WARRANTY ***
 THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES
 ARE DISCLAIMED. 
*/


require_once("class.jabberex.php"); 



function jabwebhist_error( $err )
{
	echo "<h2>Error!</h2>\n";
	echo "<p class=\"error\">$err</p>\n";
	echo '<p>Go back to the <a href="index.php">login</a> page.</p>';
	echo "</body></html>\n";
	exit();
}


function jabwebhist_connect()
{
	$JABBER = new JabberEx; 
	$JABBER->server         =  $_SESSION['server'];; 
	$JABBER->port           = 5222; 
	$JABBER->username       = $_SESSION['user']; 
	$JABBER->password       = $_SESSION['password']; 

	$_SESSION['count']++;
	$JABBER->resource       = "WebArchiveReader-" . $_SESSION['count'] ; 
	
	$JABBER->enable_logging = false; 
	$JABBER->log_filename   = 'log/logfile.txt'; 

	$JABBER->Connect() or jabwebhist_error("Couldn't connect to the XMPP server!"); 
	$JABBER->SendAuth() or jabwebhist_error("Couldn't authenticate! Check your password."); 
	
	return $JABBER;
} 

?>